require_relative "./lazylib.rb"

def make_promises(ir, ranks, types)
  promises = ir.map.with_index{|node,i|
    arg_types = node.args.map{|a|types[a]}
    arg_ranks = node.args.map{|a|ranks[a]}
    way = find_way(ir[i], arg_types, arg_ranks)

    raise IogiiError.new "arg rank(s) too low and op does not promote (see #{NittyGritty}#promotion )", node if way.impl == NoPromote

    coerces = coerce?(way.arg_types,arg_types)
    zip_level = zip_level(way, arg_ranks, arg_types)
    excess = excess_ranks(way, arg_ranks, arg_types)
#     excess.each.with_index{|e,i| raise IogiiError.new "arg #{i+1} rank is not high enough", node if e<0 }

    impl = lambda{|*args|
      $rank = way.vectorize ? way.mod : ranks[ir[i].args[0]]
      $at = coerces[0] ? CharType : arg_types[0]
      $bt = coerces[1] ? CharType : arg_types[1]
      way.impl[*args]
    }

    promise{
      args = node.args.map{|a| promises[a] }
      args = args.zip(coerces,arg_ranks).map{|a,c,r|
        c ? promise{ zipn(r, [a], ->aa{ str(aa) }) } : a }
      args = args.zip(excess).map{|a,e| promoten(-e, a) }
      new_excess = excess.map{|e| e = [e, 0].max }
      args = args.zip(new_excess).map{|a,e| repn(zip_level - e, a)}
      if node.op.name == "superpad"
        superpad(zip_level, args[0])
      else
        zipn(zip_level, args, impl)
      end
    }
  }
  promises
end
