these_tests = <<'EOF' # for general test use best name except for j, c, +
# test vectorization
3,4 2+ -> [5,6]

# test input arg
:+ -> 1554
-3 -> -774
200 mdup !+ > -> 977 200

# test op capitalization
4j 3c J 2j 1c Cons -> [[1,2],[3,4]]
# Fails because Negate is not defined
4 Negate -> block does not reach stack size 1 before program ends\nWARNING: 1:3 (Negate) splitting "Negate" into chars because no op/var by that name, but it is surrounded by whitespace indicating this might not be the intent
# Fails because needs space to parse negate as a word
+ negate + -> stack size must be >=0

# Test parse
1 mdup 1> -> 1:9 (>) unmatched >

# Test data parse
1, -> [1]
1,2, -> [1,2]
# 1,,2 ->
# 1,, ->
1,2,3 -> [1,2,3]
1,2,,3 -> [[1,2],[3]]
1,,3 -> [[1],[3]]
1,, -> [[1]]
1,,,2 -> [[[1]],[[2]]]
"1","2","3" -> ["1","2","3"]
"1", -> ["1"]
"1","2",,"3" -> [["1","2"],["3"]]
"1",,"3" -> [["1"],["3"]]
"1",, -> [["1"]]
1,"ab" -> ["1","ab"]
1,'a -> ["1","a"]
'a,"bc" -> ["a","bc"]

# Test comments
10 2# 0 -> 10 2
10 2#0 -> [1,0,1,0] 0

# Test unvec
1,2,,3,4 head, -> [1,2]
1,2,,3,4J, H, -> [[1,2],[3,4]]
5,6,,7,8J, 1,2,,3,4 C, -> [[[1,2],[3,4]],[[5,6],[7,8]]]

# Test empty program
->

# Test stack
1 mdup *> -> 1:9 (>) unmatched >

# Test blocks
5 > -> 1:3 (>) unmatched >

# Test arg use
3 mdup $ + > -> 6 3

# Test char
'a -> 'a
"asdf" -> "asdf"
"123","asdf" -> ["123","asdf"]
# ' -> 1:1 (') empty char
"a -> 1:1 ("a) unterminated string

# Test escapes (todo)

# Test overload
"asdf" 1 + -> "bteg"
"bteg" 1 - -> "asdf"
"a" "b" + -> 1:9 (+) op is not defined for base types: char char

# Test adjacent ids
"asdf"th -> 's
"asdf"t10+ -> "}np"
"asdf"t0010 -> "sdf" 0 0 10

# Test truthiness
1,0 not -> [0,1]
"a\n\0 ." not -> [0,1,1,1,0]
# todo chars 9 and 11
"a","" Not -> [0,1]

# Test meta ops #############
7 dup + -> 14
10 mdup 1+> 1-* -> 99

# ! outer
! -> 1:1 (!) no outer stack in main
100 7 mdup !* > + -> 707
100 0 foldr 1,2,3,4+!+ > -> 410

# Test var stack
5 [ 6 ] -> 5 6 5
5 ] -> 1:3 (]) var stack is empty, cannot pop

# Test vars
4=xyz xyz+ -> 8
4=3 3+ -> 8
3=+ + -> 3 3
3 1 cons = 3 5 take -> [1,1,1,1,1]

# Test register
1@ 2@ 3@ -> 1 3 2 3 3

# Test inspect
1 inspect -> "1"
1j inspect -> "[1]"

1 type -> "int"
1j type -> "[int]"
'c type -> "char"
"" type -> "[char]"
nil type -> "[]"

# Test errors, the 1 is so that there can be a space before a single word
!, -> undefined
1 undefined -> 1 undefined
undefined type -> "empty"
undefined, type -> "[]"
# !,, type   todo
# 1 undefined + -> undefined
# 1 undefined + type -> "int"
# undefined 'c cons -> undefined
# undefined 'c cons type -> "[char]"
# "errorz" error -> errorz
# "errorz" error type -> "empty"

# Test that empty type auto increases rank
nil "a" Cons -> ["a"]

# nil 1+ dup type -> [] "[int]"

# Test implicit >
iterate0 1+ negate 5 take -> [0,-1,-2,-3,-4]

# test infinite type
meld just -> 1:6 (just) cannot construct the infinite type
# inner push/pop
0 iterate [ 1+ > 5 keep  ] 6 keep -> [0,1,2,3,4] [0,1,2,3,4,5]
0 iterate = peek 1+ > 5 keep  peek 6 keep -> [0,1,2,3,4] [0,1,2,3,4,5]

# Test block using ops ######

# iterate
0 iterate 1,2,3+ > -> [0,1,3,6]
0 iterate dup 1 c + > t t t tail t t t head -> 13
1,2 Iterate 3,4 c > -> [[1,2],[3,1,2],[4,3,1,2]]

# foldr
0 foldr 1,2,3+ > -> 6
1,2 Foldr 3,4 c > -> [3,4,1,2]
0 foldr 1,2,,3,4+ > -> [3,7]
0 foldr 1,2,,3,4 mdup j > c+ > -> [[2,4],[6,8]]

# iterate0
iterate0 1+ > 5 take -> [0,1,2,3,4]
Iterate0 "ab","cd","ef" append > -> ["","ab","abcd","abcdef"]
Expand "ab","cd","ef" append > -> ["","ab","abcd","abcdef"]
iterate0 'a cons > 5 take -> " a a "

# foldr0
foldr0 1,2,3 + > -> 6
Foldr0 "ab","cd","ef" append > -> "efcdab"
Meld "ab","cd","ef" append > -> "efcdab"

# superpad
1,2,3 Iterate tail > 5 Take -> [[1,2,3],[2,3],[3],[],[]]
1,2,3 J Iterate tail > 5 Take -> [[[1,2,3],[2,3],[3],[],[]]]
1,2,3 j Iterate, Tail > 5 Take, -> [[[1],[2],[3]],[[2],[3]],[[3]],[],[]]

# Test ops ##################
# head
"asdf" head -> 'a
# 'c head -> 1:4 (head) arg 1 rank is not high enough
"" head 2 -> '  2
1 j tail head -> 0

# tail
"asdf" tail -> "sdf"
# 'c tail -> 1:4 (tail) arg 1 rank is not high enough
# "" tail -> sdf todo same for head
"" tail -> ""

# arithmetic
1 2+ -> 3
1 2- -> -1
1 2* -> 2
1 2/ 2 2/ -> 0 1
1 0/ -> 0
1 negate -> -1
1 2% 2 2% 1 negate 3% -> 1 0 2
3 0 % -> 0
2 3^ -> 8
0 0^ -> 1
5 countTo 3- 1~ ^ -> [0,-1,0,1,0]
5 countTo 3- 2~ ^ -> [0,1,0,1,0]

# sum
1,2,3 sum -> 6
2j tail sum -> 0
"abc" sum -> 294
1,2,3,4 prod -> 24
2j tail prod -> 1


# chr
100 chr -> 'd

# str
123 str 1+ -> "234"

# read
"" read -> 0
"b122a" read 1+ -> 123

# readAll
"1 2 ab3 -4 --5" readAll -> [1,2,3,-4,5]

'd ord -> 100

"\nab\nc\n\nd\n" lines -> ["","ab","c","","d"]
"1\n\n" lines -> ["1",""]

" \n\0a b " strip -> "a b"

"ab" 5 retell -> "ababababab"

"ab","cd" " " * -> "ab cd"

" ab  cd e " " " cut -> ["","ab","","cd","e",""]

" ab  cd e " " " split -> ["ab","cd","e"]

# ifelse
0 1 2 ifelse 1 1 2 ifelse -> 2 1
" a" 1 2 ifelse -> [2,1]

# take
"abcde" 2 take -> "ab"

# drop
"abcde" 2 drop -> "cde"

# repeat
1 repeat 3 take -> [1,1,1]

# append
"abc" "123" append -> "abc123"

# pair
1 2 pair -> [1,2]

# or
1 2 or -> 1
0 2 or -> 2
1j tail 2j Or -> [2]
"" "a" Or -> "a"

100 "ab" or -> "10"
0 "ab" Or -> "ab"
1 "ab" Or -> "1"
0j "ab" Or -> ["ab"]
0 tail "ab" Or dup type -> [] "[[char]]"

# and
1 2 and -> 2
0 2 and -> 0

# equal
0,1 0,2 equal -> [1,0]
0,1 0,1 Equal -> 1
0,1 0,2 Equal -> 0
0,1 0j Equal -> 0
"ab" "a" Equal -> 0
"a" "ab" Equal -> 0
"ab" "ab" Equal -> 1
"ab" "ac" Equal -> 0

# lessThan
2 3 < -> 1
1 1 < -> 0
"ab" "a" LessThan -> 0
"a" "ab" LessThan -> 1
"ab" "ab" LessThan -> 0
"ab" "ac" LessThan -> 1

# greaterThan
3 2 greaterThan -> 1
1 1 greaterThan -> 0
"ab" "a" GreaterThan -> 1
"a" "ab" GreaterThan -> 0
"ab" "ab" GreaterThan -> 0
"ab" "ac" GreaterThan -> 0

# reverse
"asdf" reverse -> "fdsa"

# pad
5j 1 pad 3 take -> [5,1,1]

# groupWhile
"a b": groupWhile -> ["a","b"]

# len
"asdf" len -> 4

# sort
"asdf" sort -> "adfs"

# sortBy
"12345" "asdfe" sortBy -> "13542"
"ab","aa" : SortBy -> ["aa","ab"]

# filter
"123" "a a" filter -> "13"

# uniq
"acaabc" uniq -> "acb"

# tally
"abaacb" tally -> [0,0,1,2,0,1]

# transpose
"abc","1" transpose -> ["a1","b","c"]

# toBase
10 2 toBase -> [1,0,1,0]
10 2 # -> [1,0,1,0]
10,10 2 #, -> [[1,0,1,0],[1,0,1,0]]
1,2,3 10 fromBase -> 123
1,2,3 10 # -> 123

# abs
5 negate abs -> 5
5 abs -> 5

# inc/etc
5 ) -> 6
'a ) -> 'b
5 ( -> 4
'b ( -> 'a

wholes 4 take -> [0,1,2,3]
4 countTo -> [1,2,3,4]

# reshape
"abcdefg" 2 reshape -> ["ab","cd","ef","g"]

# last
"asdf" last -> 'f
1, tail last -> 0

# init
"asdf" init -> "asd"
"" init -> ""

# concat
"asdf","12" concat -> "asdf12"

# setdiff
"abcad" "babc" setDiff -> "ad"

# takeWhile
"123 456" dup takeWhile -> "123"

# min max
1 2 min -> 1
"ab" "aa" min -> "aa"

1 2 max ->2
"ab" "aa" max -> "ab"

# tails
"abc" tails -> ["abc","bc","c",""]

# inits
Expand "abc" cons > reverse -> ["","a","ab","abc"]

# coercion
123 "abc" cons -> ["a123","b123","c123"]
"abc" 123 cons -> ["1abc","2abc","3abc"]
1,2,3 " "* -> "1 2 3"
123 j "abc" cons -> ["a123"]

# promotes
"a b" '  split -> ["a","b"]
# "abc" " " join -> "a b c"  todo
"a" 'a Q -> 1
1 2 cons -> [2,1]

# special promotes
"asdf" "b" join -> "absbdbf"
123 "b" join -> "1b2b3"
"az","bx" 2,1 SortBy -> ["bx","az"]
"az","bx" 2,1 sortBy, -> ["bx","az"]
"abc" 3 sortBy -> cannot sortby negative rank

2 . -> 100
1,2 ., -> [10,100]
1 B -> [1,2,3,4,5,6,7,8,9,10]
1,0 B -> [[1,2,3,4,5,6,7,8,9,10],[1]]
1,0,,0 B, -> [[[1,2,3,4,5,6,7,8,9,10],[1]],[[1]]]
1,0,,0 B ->[[0],[1,0]]
"abc" _ -> 294

'a "b" join -> 1:8 (join) arg rank(s) too low and op does not promote (see https://golfscript.com/iogii/nittygritty.html#promotion )
4 head -> 1:3 (head) arg rank(s) too low and op does not promote (see https://golfscript.com/iogii/nittygritty.html#promotion )
4, Head -> 1:4 (Head) arg rank(s) too low and op does not promote (see https://golfscript.com/iogii/nittygritty.html#promotion )
1 iterate head -> 1:3 (iterate) arg rank(s) too low and op does not promote (see https://golfscript.com/iogii/nittygritty.html#promotion )
3j 1 ? -> [[3]]
3 1 ? -> [1,1,1]
123 digits -> [1,2,3]
123 \ -> [1,2,3]
12,34 \ -> [[1,2],[3,4]]
11,2,,3,4 \ -> [[11,3],[2,4]]
11,2,,3,4 \, -> [[[1,1],[2]],[[3],[4]]]
1,2,3 undigits -> 123
1,2,3 U -> 123
1,2,,3,4 U -> [12,34]
1,2,,3,4,,,5 U -> [[1,2],[3,4],[5]]
1,2,,3,4,,,5 U, -> [[12,34],[5]]
1 U -> 1:3 (U) arg rank(s) too low and op does not promote (see https://golfscript.com/iogii/nittygritty.html#promotion )
1 u -> 1:3 (u) arg rank(s) too low and op does not promote (see https://golfscript.com/iogii/nittygritty.html#promotion )
1j u -> 1:4 (u) arg rank(s) too low and op does not promote (see https://golfscript.com/iogii/nittygritty.html#promotion )
1jj u, -> 1:5 (u,) arg rank(s) too low and op does not promote (see https://golfscript.com/iogii/nittygritty.html#promotion )

9 H -> 1:3 (H) arg rank(s) too low and op does not promote (see https://golfscript.com/iogii/nittygritty.html#promotion )

EOF
# ' # "

# things that this doesn't test
# arg use (todo)
# io
# alias

require "./run.rb"
require 'stringio'

Arg = new_op("data", "int"){ 777 }

def runtest(result, prog)
  ir, ir_inds, types, ranks, promises, preprint_ids = run(prog, Arg)
  raise if !preprint_ids.empty?

  ir_inds.each{|ir_ind|
    result << " " if !result.empty?
    value = inspectv(types[ir_ind], ranks[ir_ind], promises[ir_ind])
    result << to_eager_str(value)
  }
  result
end

start_line = 1
tests = these_tests.lines.map{|line|
  start_line += 1
  next if line.strip == "" || line =~ /^\#/
  prog, expected=line.split("-"+">")
  expected.gsub!('\n', "\n")
  [prog, expected, "test.rb, line #{start_line}"]
}.compact

Dir["docs/*"].each{|file|
  File.read(file).lines.each.with_index{|line,line_no|
    if line =~ /^(.*)->(.*)/
      where = "#{file}, line #{line_no+1}"
      raise "need to indent code at #{where}" if $1[0,4]!=" "*4
      tests << [$1, $2, where]
    end
  }
}

OpExamples.each{|names,example|
  if example =~ /^(.*)->(.*)/
    tests << [$1, $2, "op example: %s" % names]
  end
}

pass = 0
tests.each{|test|
  $stderr = StringIO.new

  prog, expected, from = *test
  expected = "" if !expected
  expected.strip!
  prog.strip!
  begin
    found = ""
    runtest(found, prog)
    errored = false
  rescue Exception
    errored = $!
    found << $!.message.gsub(IogiiError.new("").message, "")
  end
  found += "\n"+$stderr.string
  found.strip!
  expected.gsub!("WARNING: ","WARNING: ".red)

  if found != expected
    STDERR.puts "FAIL: #{from}"
    STDERR.puts prog
    STDERR.puts "expected:"
    STDERR.puts expected
    STDERR.puts "found:"
    STDERR.puts found
    raise errored if errored
    exit(1)
  end

  pass += 1
}

puts "PASS #{pass} tests"
